#include	"header.h"

#include	<string.h>

static Atom	selection_property, incr_type;

void init_eventhandler(void)
{
    selection_property = XInternAtom (dpy, "TEST_PROP", False);
    incr_type = XInternAtom(dpy, "INCR", False);
}


static void incr_loop(Window win, Atom property)
{
    int		format;
    Atom	type_return, type = None;

    unsigned char	*data;
    unsigned long	nitems, bytes_left, total;

    XEvent	ev;

    while (1)
    {
        XNextEvent(dpy, &ev);

        printf("Type: %d, %d\n", PropertyNotify, ev.type);
        

         if (ev.type != PropertyNotify)
             continue;

        printf("Atom: %s, %s\n", XGetAtomName(dpy, property),
               XGetAtomName(dpy, ev.xproperty.atom));
        printf("State: %d, %d\n", PropertyNewValue, ev.xproperty.state);

        if (ev.xproperty.state == PropertyNewValue)
        {
            XGetWindowProperty(dpy, win, property,
                               0L, 4096L, False, AnyPropertyType, &type_return,
                               &format, &nitems, &bytes_left, &data);

            if (format != 8 || (type != None && type != type_return))
            {
                XDeleteProperty(dpy, win, property);
                XFlush(dpy);
                XFree(data);
                continue;
            }

            if (nitems == 0)
            {
                XDeleteProperty(dpy, win, property);
                XFlush(dpy);
                XFree(data);
                break;
            }


            printf("nitems: %d, bytes_left: %d\n", nitems, bytes_left);
            printf("%s", data);
            XFree(data);

            for (total = nitems;
                 bytes_left;)
            {
                XFlush(dpy);
                printf("nitems: %d, bytes_left: %d\n", nitems, bytes_left);
		XGetWindowProperty(dpy, win, property,
				   (total/4L), 4096L, False,
				   AnyPropertyType, &type_return,
				   &format, &nitems, &bytes_left,
				   &data);
                printf("nitems: %d, bytes_left: %d\n", nitems, bytes_left);

                total += nitems;
                printf("%s", data);
		
		XFree(data);
            }

            XDeleteProperty(dpy, win, property);
            XFlush(dpy);
        }
    }
}


int selection_notify(XSelectionEvent ev)
/* This function is passed the event that was
** triggered if it is a SelectionNotify type. */
{
	char	*buffer, *buff_p;
	int	format;
	Atom	type_return;

	unsigned char	*data;
	unsigned long	nitems, bytes_left, total;


	if (ev.property == None)
		return 1; /* The selection failed. */

	XGetWindowProperty(dpy, ev.requestor, ev.property,
			   0L, 4096L, False, AnyPropertyType, &type_return,
			   &format, &nitems, &bytes_left, &data);

	if (type_return == incr_type)
        {
            XDeleteProperty(dpy, ev.requestor, ev.property);
            XFlush(dpy);
            printf("%d\n", (long)*data);
            incr_loop(ev.requestor, ev.property);
            return 1;
        }

        if (format != 8 || nitems == 0)
            return 1;


        printf("%s", data);
	XFree(data);

	for (total = nitems; bytes_left;)
	{
		XGetWindowProperty(dpy, ev.requestor, ev.property,
				   (total / 4L), 4096L, False,
				   AnyPropertyType, &type_return,
				   &format, &nitems, &bytes_left,
				   &data);

		printf("%s", data);
                total += nitems;
		XFree(data);
	}

	XDeleteProperty(dpy, ev.requestor, selection_property);
	/* we are done, tell the owner */
        XFlush(dpy);

	return 1;
}

int buttonPress(XButtonEvent ev)
{
    if (ev.button == 2)
    {
        printf("trying to convert selection\n");
        XConvertSelection(dpy, XA_PRIMARY, XA_STRING, selection_property,
                          ev.window, ev.time);
    }
    return 1;
}




/* End of example specific code */

int clientMessage(XClientMessageEvent ev)
{
    if (ev.format == 32 && ev.data.l[0] == delete_window)
    {
        printf("Delete window request\n");
        return 0;
    }

    printf("Unknown client message event\n");
    return 1;
}

int selectionRequest(XSelectionRequestEvent ev)
{
    return 1;
}

int propertyNotify(XPropertyEvent ev)
{
    return 1;
}


int buttonRelease(XButtonEvent ev)
{
    return 1;
}

int expose(XExposeEvent ev)
{
    return 1;
}

int configureNotify(XConfigureEvent ev)
{
    return 1;
}

int motion(XMotionEvent ev)
{
    return 1;
}
