#include	"header.h"

#include	<string.h>

static Atom	selection_property;

void init_eventhandler(void)
{
    selection_property = XInternAtom (dpy, "TEST_PROP", False);
}


int selection_notify(XSelectionEvent ev)
/* This function is passed the event that was
** triggered if it is a SelectionNotify type. */
{
	char	*buffer, *buff_p;
	int	format;
	Atom	type_return;

	unsigned char	*data;
	unsigned long	nitems, bytes_left, total;


	if (ev.property == None)
		return 1; /* The selection failed. */

	XGetWindowProperty(dpy, ev.requestor, selection_property,
			   0L, 4096L, False, AnyPropertyType, &type_return,
			   &format, &nitems, &bytes_left, &data);

        printf("%s\n", XGetAtomName(dpy, type_return));

	if (format != 8 || nitems == 0)
	{
	    /* We have no idea what language this guy is talkin */
            /* So don't touch it or the owner will think we do */
		return 1;
	}

	buff_p = buffer = (char*)malloc(nitems);
	memcpy(buffer, data, nitems);
	XFree(data);

        printf("nitems: %d, bytes_left: %d\n", nitems, bytes_left);

	for (total = nitems; bytes_left;)
	{
             printf("nitems: %d, bytes_left: %d\n", nitems, bytes_left);

		buff_p += nitems;
		XGetWindowProperty(dpy, ev.requestor, selection_property,
				   (total / 4L), 4096L, False,
				   AnyPropertyType, &type_return,
				   &format, &nitems, &bytes_left,
				   &data);

		total += nitems;
		realloc(buffer, total);
		memcpy(buff_p, data, nitems);
		XFree(data);
	}

	XDeleteProperty(dpy, ev.requestor, selection_property);
	/* we are done, tell the owner */
        XFlush(dpy);

	printf("%s", buffer);
	free(buffer);

	return 1;
}

int buttonPress(XButtonEvent ev)
{
    if (ev.button == 2)
    {
        printf("trying to convert selection\n");
        XConvertSelection(dpy, XA_PRIMARY, XA_STRING, selection_property,
                          ev.window, ev.time);
    }
    return 1;
}




/* End of example specific code */

int clientMessage(XClientMessageEvent ev)
{
    if (ev.format == 32 && ev.data.l[0] == delete_window)
    {
        printf("Delete window request\n");
        return 0;
    }

    printf("Unknown client message event\n");
    return 1;
}

int selectionRequest(XSelectionRequestEvent ev)
{
    return 1;
}

int propertyNotify(XPropertyEvent ev)
{
    return 1;
}


int buttonRelease(XButtonEvent ev)
{
    return 1;
}

int expose(XExposeEvent ev)
{
    return 1;
}

int configureNotify(XConfigureEvent ev)
{
    return 1;
}

int motion(XMotionEvent ev)
{
    return 1;
}
