#include	"header.h"


void newWindow(Window *new_window, int x, int y, int width, int height)
{

    int	screen;

    screen = DefaultScreen(dpy);

    *new_window = XCreateSimpleWindow(dpy, RootWindow(dpy, screen),
                                     x, y, width, height, 0,
                                     BlackPixel(dpy, screen),
                                     WhitePixel(dpy, screen));

    delete_window = XInternAtom(dpy, "WM_DELETE_WINDOW", False);
/*
    XMapWindow(dpy, new_window);
    XFlush(dpy);
*/
    XSetWMProtocols(dpy, *new_window, &delete_window, 1);
    XSelectInput(dpy, *new_window, EV_MASK);
}

int event_check(void)
{
    XEvent ev;

    XNextEvent(dpy, &ev);

    switch (ev.type)
    {
        case ClientMessage:
            printf("Recieved a client message\n");

            return clientMessage(ev.xclient);

            break;


        case SelectionNotify:
            printf("Recieved a SelectionNotify\n");

            return selection_notify(ev.xselection);

            break;


            
        case SelectionRequest:
            printf("Recieved request for the selection\n");

            return selectionRequest(ev.xselectionrequest);

            break;


        case PropertyNotify:
            printf("Recieved PropertyNotify\n");

            return propertyNotify(ev.xproperty);

            break;


        case ButtonPress:
            printf("Button pressed\n");

            return buttonPress(ev.xbutton);

            break;


        case ButtonRelease:
            printf("Button released\n");

            return buttonRelease(ev.xbutton);

            break;


            
        case Expose:
            printf("Window Exposed\n");

            return expose(ev.xexpose);

            break;


        case ConfigureNotify:
            printf("Window configuration has changed\n");

            return configureNotify(ev.xconfigure);

            break;

        case MotionNotify:
            

            return motion(ev.xmotion);

            break;


        case UnmapNotify:
            printf("Unmapped\n");
            return 1;
            break;


        case MapNotify:
            printf("Mapped\n");
            return 1;
            break;


        default:
            printf("Unknown event\n");
            return 1;

    }
}
